<%@ taglib prefix="cs" uri="futuretense_cs/ftcs1_0.tld" %>
<%@ taglib prefix="ics" uri="futuretense_cs/ics.tld" %>
<%@ taglib prefix="satellite" uri="futuretense_cs/satellite.tld" %>
<%//
// fatwire/dash/attributerenderers/htmltextdataRenderer
//
// INPUT
//
// OUTPUT
//%>
<%@ page import="COM.FutureTense.Interfaces.FTValList" %>
<%@ page import="COM.FutureTense.Interfaces.ICS" %>
<%@ page import="COM.FutureTense.Interfaces.IList" %>
<%@ page import="COM.FutureTense.Interfaces.Utilities" %>
<%@ page import="COM.FutureTense.Util.ftErrors" %>
<%@ page import="COM.FutureTense.Util.ftMessage"%>
<%@ page import="javax.faces.context.ResponseWriter"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderDataContext"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderConstants"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.fatwire.assetapi.def.AttributeDef"%>
<%@ page import="com.fatwire.assetapi.def.AttributeTypeEnum"%>
<%@ page import="com.fatwire.assetapi.data.AttributeData"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.AttributeEditor"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.Asset"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.AssetRenderUtil"%>
<%@ page import="javax.faces.component.UIComponent"%>
<%@ page import="com.fatwire.cs.ui.view.backing.GenericUtil"%>


<cs:ftcs>

<%

	/**
		Varaibles available for attribute renderer are
			1) RenderDataContext - Holds the details about the asset , attribute , attribute data and attribute editor
			2) mode - Which is either paint or update
			3) ResponseWriter - Wrtier to which the html is written to (similar to JSPWriter object(out)).

		RenderDataContext object has the following attributes
			1) Asset - the whole asset object (can be retrived using context.getAsset() method).
			2) AttributeName - name of the attribute (can be retrived using context.getAttributeName() method).
			3) AttributeEditor - Object which holds the details about the attribute editor.The attributes defined in attribute editor 
								xml will be available in this object (can be retrieved using context.getEditor() method).
			4) AttributeDef - AssetApi attribute defintion object which has the properties of the attribute (can be retrieved using context.getAttribuetDef() method).					
			5) AttributeData - AssetApi attribute data object which has the attribute data (can be retrived using context.getAttributeData() method).
			6) isMetaAttribute - boolean property to determine whether the attribute is userdefined or not
			
	*/
	// Get the writer
	ResponseWriter writer =(ResponseWriter ) request.getAttribute("writer");
	// get the mode
	String mode = (String ) request.getAttribute("mode");	
	UIComponent component = (UIComponent ) request.getAttribute("component");
	// get the context
	RenderDataContext renderContext =(RenderDataContext ) request.getAttribute("renderdatacontext");
	// populate unique name for the input field
	String id =  "description";	 
	
	if("paint".equals(mode))
	{
		AttributeDef def = renderContext.getAttributeDef ();
		AttributeEditor editor = renderContext.getEditor ();
		// get the length of the field if specified in the attribute editor property
		int xsz = GenericUtil.getValidInt((String)editor.getProperty(RenderConstants.TEXTFIELD.XSIZE));
        if(-1 == xsz)
        {
            xsz = 97;
        }	
		// get the Instrucion text if any		
		String toolTip = (String)editor.getProperty(RenderConstants.INSTRUCTION);
        		String label = AssetRenderUtil.getLabelText(renderContext.getLabel());
		// get the label style.This is the style used by the labels in dash
		String labelStyle = renderContext.getLabelStyle();
		List data = renderContext.getAttributeData().getDataAsList();
		String value = data.size() > 0 ? data.get(0).toString() : "";		
				
		StringBuilder ouput = new StringBuilder();
		// generate the inputfields
		// Build a row for displaying the attribute
		ouput.append("<tr><td>");
		ouput.append("<table><tr><td>");
		ouput.append("<table align='left' class='"+labelStyle+"'><tr><td>");
		ouput.append(label);
		ouput.append("</td></tr></table>");
		ouput.append("</td></tr>");
		ouput.append("<tr><td>");
		ouput.append("<table align='left'><tr><td>");
		ouput.append("<input type='text' class='AFFieldText' value='"+value+"' name='"+id+"' size='"+xsz+"'><tr><td>");		
		ouput.append("</td></tr></table>");
		ouput.append("</td></tr>");
		ouput.append("<tr><td>");		
		ouput.append("</td></tr>");

		ouput.append("</table></td>");
		ouput.append("</tr>");		
		writer.write(ouput.toString());
			
	} 

%>

</cs:ftcs>