<%@ taglib prefix="cs" uri="futuretense_cs/ftcs1_0.tld" %>
<%@ taglib prefix="ics" uri="futuretense_cs/ics.tld" %>
<%@ taglib prefix="satellite" uri="futuretense_cs/satellite.tld" %>
<%//
// fatwire/dash/attributerenderers/multiValuedTextRenderer
//
// INPUT
//
// OUTPUT
//%>

<%@ page import="COM.FutureTense.Interfaces.FTValList" %>
<%@ page import="COM.FutureTense.Interfaces.ICS" %>
<%@ page import="COM.FutureTense.Interfaces.IList" %>
<%@ page import="COM.FutureTense.Interfaces.Utilities" %>
<%@ page import="COM.FutureTense.Util.ftErrors" %>
<%@ page import="COM.FutureTense.Util.ftMessage"%>
<%@ page import="javax.faces.context.ResponseWriter"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderDataContext"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.RenderConstants"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Map"%>
<%@ page import="com.fatwire.assetapi.def.AttributeDef"%>
<%@ page import="com.fatwire.assetapi.def.AttributeTypeEnum"%>
<%@ page import="com.fatwire.assetapi.data.AttributeData"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.AttributeEditor"%>
<%@ page import="com.fatwire.cs.ui.model.bo.asset.Asset"%>
<%@ page import="com.fatwire.cs.ui.view.renderer.AssetRenderUtil"%>
<%@ page import="javax.faces.component.UIComponent"%>
<%@ page import="java.util.StringTokenizer"%>
<%@ page import="com.fatwire.cs.ui.view.util.FacesUtils"%>
<%@ page import="com.fatwire.assetapi.def.AttributeDefProperties.ValueCount"%>
<%@ page import="java.io.IOException"%>
<%@ page import="javax.faces.context.FacesContext"%>
<%@ page import="com.fatwire.cs.ui.view.backing.GenericUtil" %>
<%@ page import="com.fatwire.cs.ui.view.constant.*" %>

<cs:ftcs>

<%

    /**
     Varaibles available for attribute renderer are
     1) RenderDataContext - Holds the details about the asset , attribute , attribute data and attribute editor
     2) mode - Which is either paint or update
     3) ResponseWriter - Wrtier to which the html is written to (similar to JSPWriter object(out)).

     RenderDataContext object has the following attributes
     1) Asset - the whole asset object (can be retrived using context.getAsset() method).
     2) AttributeName - name of the attribute (can be retrived using context.getAttributeName() method).
     3) AttributeEditor - Object which holds the details about the attribute editor.The attributes defined in attribute editor
     xml will be available in this object (can be retrieved using context.getEditor() method).
     4) AttributeDef - AssetApi attribute defintion object which has the properties of the attribute (can be retrieved using context.getAttribuetDef() method).
     5) AttributeData - AssetApi attribute data object which has the attribute data (can be retrived using context.getAttributeData() method).
     6) isMetaAttribute - boolean property to determine whether the attribute is userdefined or not

     */
    // Get the writer
    ResponseWriter writer = (ResponseWriter)request.getAttribute("writer");
    // get the mode
    String mode = (String)request.getAttribute("mode");
    UIComponent component = (UIComponent)request.getAttribute("component");
    // get the context
    RenderDataContext renderContext = (RenderDataContext)request.getAttribute("renderdatacontext");
    // populate unique name for the input field
    String uniqueId = generateID(renderContext);
    if("paint".equals(mode))
    {
        // get the attribute defintion
        AttributeDef def = renderContext.getAttributeDef();
        // get the attribute editor
        AttributeEditor editor = renderContext.getEditor();
        String toolTip = (String)editor.getProperty(RenderConstants.INSTRUCTION);
        String label = AssetRenderUtil.getLabelText(renderContext.getLabel());
        String labelStyle = renderContext.getLabelStyle();
        // get the data
        List data = renderContext.getAttributeData().getDataAsList();
        // get the value count of the attribute. (determines whether the attribute is single valued or multivalued)
        ValueCount valueCount = def.getProperties().getValueCount();
        if(data.isEmpty())
        {
            data.add("");
        }
        int size = data.size();
        // include the javascript file
        renderScriptOnce(writer, component);
        StringBuilder ouput = new StringBuilder();
        // Build a row for displaying the attribute
        ouput.append("<tr><td>");
        ouput.append("<table><tr><td>");
        ouput.append("<table align='left' class='" + labelStyle + "'><tr><td>");
        ouput.append(label);
        ouput.append("</td></tr></table>");
        ouput.append("</td></tr>");
        ouput.append("<tr><td><table id=\"" + uniqueId + "_controlstable\">");
        ouput.append("<tbody id=\"" + uniqueId + "_controlstablebody\">");
        int counter = 1;
        String indices = "1";
        ViewConstants viewConstants = (ViewConstants)FacesUtils.getManagedBean(BeanNames.BACKING_VIEWCONSTANTS);

        String up = ViewConstants.IMAGE_DIR + "/up.gif";
        String upHover = ViewConstants.IMAGE_DIR + "/uphover.gif";
        String upHint = GenericUtil.getLocalizedValue(LabelConstants.moveUp);

        String down = ViewConstants.IMAGE_DIR + "/down.gif";
        String downHover = ViewConstants.IMAGE_DIR + "/downhover.gif";
        String downHint = GenericUtil.getLocalizedValue(LabelConstants.moveDown);

        String delete = ViewConstants.IMAGE_DIR + "/delete.gif";
        String deleteHover = ViewConstants.IMAGE_DIR + "/deletehover.gif";
        String deleteHint = GenericUtil.getLocalizedValue(LabelConstants.delete);

        String addNew = viewConstants.getLocalizedImageDir() + "/addnew.gif";
        String addNewHover = viewConstants.getLocalizedImageDir() + "/addnewBlue.gif";
        String addNewHint = GenericUtil.getLocalizedValue(LabelConstants.addNew);

        System.out.println(" <JAG IS COMING BACK> Product Add New Button Hint: "+addNewHint);

        // Loop through the available data and display all of them
        for(Object value : data)
        {
            ouput.append("<tr id=\"" + uniqueId + "_controlsrow_" + counter + "\">");
            ouput.append("<td><input type=\"text\" class='AFFieldText' name=\"" + uniqueId + "_input_" + counter + "\" id=\"" + uniqueId + "_input_" + counter + "\" value=\"" + value.toString() + "\" size=\"97\"></td>");
            ouput.append("<td>");
            ouput.append("<table>");
            ouput.append("<tbody id=\"" + uniqueId + "_buttonstable_" + counter + "\">");
            ouput.append("<tr>");
            ouput.append("<td>");
            ouput.append("<img src='" + up + "' alt='"+upHint+"' onmouseover=\"swap(this,'" + upHover + "')\" onmouseout=\"swap(this,'" + up + "')\" id=\"" + uniqueId + "_upbutton_" + counter + "\" ");
            if(counter == 1)
            {
                ouput.append("style=\"display: none\" ");
            }
            ouput.append(" onclick=\"moveUp('" + uniqueId + "'," + counter + ")\"></td>");
            ouput.append("<td>");
            ouput.append("<img src='" + down + "' alt='"+downHint+"' onmouseover=\"swap(this,'" + downHover + "')\" onmouseout=\"swap(this,'" + down + "')\" id=\"" + uniqueId + "_downbutton_" + counter + "\" ");
            if(size == 1 || counter == size)
            {
                ouput.append("style=\"display: none\" ");
            }
            ouput.append(" onclick=\"moveDown('" + uniqueId + "'," + counter + ")\"></td>");
            ouput.append("<td>");
            ouput.append("<img src='" + delete + "' alt='"+deleteHint+"' onmouseover=\"swap(this,'" + deleteHover + "')\" onmouseout=\"swap(this,'" + delete + "')\" id=\"" + uniqueId + "_deletebutton_" + counter + "\" ");
            if(size == 1)
            {
                ouput.append("style=\"display: none\" ");
            }
            ouput.append(" onclick=\"removeRow('" + uniqueId + "'," + counter + ")\"></td>");
            ouput.append("</tr>");
            ouput.append("</tbody>");
            ouput.append("</table>");
            ouput.append("</td>");
            ouput.append("</tr>");
            if(counter > 1)
            {
                indices = indices + "," + counter;
            }
            counter++;
        }
        ouput.append("</tbody></table></td></tr>");
        // if the attribute is multivalued add the add new button
        if(valueCount == ValueCount.MULTI || valueCount == ValueCount.MULTI_ORDERED)
        {
            ouput.append("<tr><td><table id=\"" + uniqueId + "_addnewTable\">");
            ouput.append("<tr><td>");
            ouput.append("<img src='" + addNew + "' alt='"+addNewHint+"' onmouseover=\"swap(this,'" + addNewHover + "')\" onmouseout=\"swap(this,'" + addNew + "')\" onclick=\"addnewRow('"+uniqueId+"','"+upHint+"','"+downHint+"','"+deleteHint+"')\">");
            ouput.append("<input type=\"hidden\" name=\"" + uniqueId + "_hiddenindices\" id=\"" + uniqueId + "_hiddenindices\" value=\"" + indices + "\">	");
            ouput.append("</td>");
            ouput.append("</tr>");
        }
        ouput.append("</table></td></tr></table></td></tr>");
        // write  to the writer
        writer.write(ouput.toString());


    }
    else if("update".equals(mode))
    {
        Map requestMap = (Map)request.getAttribute("requestParameterMap");
        //Update the attribute data by reading from the request parameter map
        // hidden indices is the hidden variable which holds the indexes of the available attribute values
        String hiddenIndices = ((String)requestMap.get(uniqueId + "_hiddenindices")).trim();
        List data = renderContext.getAttributeData().getDataAsList();
        data.clear();
        StringTokenizer st = new StringTokenizer(hiddenIndices, ",");
        while(st.hasMoreTokens())
        {
            String t = st.nextToken();
            String key = uniqueId + "_input_" + t;
            String text = (String)requestMap.get(key);
            data.add(text);
        }
    }

%>

<%!
	 private String generateID(RenderDataContext context)
    {
       return formatId((new StringBuilder()).append("INPUT_").append(context.getTabName()).append("_")
                                                             .append(context.getLocale()).append("_")
                                                             .append(context.getAttributeName()).append("_")
                                                             .append(context.isMetaAttribute()).append("_")
                                                             .append(context.getAttributeIndex()).toString());
    }

	
	private String formatId(String input)
    {
        // Add underscore for the id.Because ADF does not like the id to start with numbers
        input = "_" + input;
        if(input != null)
        {
            return input.replaceAll("\\W", "_");
        }
        return "";
    }
    
	/**
		Make sure the javascript file is loaded only once even if the renderer is used for multiple attributes
	*/
	private void renderScriptOnce(ResponseWriter responsewriter, UIComponent uicomponent) throws IOException
    {
	    Map requestMap = FacesContext.getCurrentInstance ().getExternalContext ().getRequestMap ();
        Boolean loaded = (Boolean)requestMap.get("multivalued-script-rendered");
        if(loaded == Boolean.TRUE)
        {
            return;
        } else
        {
		requestMap.put("multivalued-script-rendered", Boolean.TRUE);
        responsewriter.startElement("script", uicomponent);
        responsewriter.writeAttribute("type", "text/javascript", null);
        String s1 = "faces/js/multivalued.js";
        responsewriter.writeAttribute("src", s1, null);
        responsewriter.endElement("script");
        responsewriter.write("\n");
        return;
        }
    }

	
%>

</cs:ftcs>